Subject: [PATCH] This adds a generic PWM framework driver for the PWM controller

From: [email-masked] (Alexandre Belloni)
Date: Sun, 14 Sep 2014 13:19:01 +0200

On 19/08/2014 at 08:11:40 -0400, jonsmirl at gmail.com wrote :
> On Mon, Aug 18, 2014 at 4:19 PM, Maxime Ripard
> <[email-masked]> wrote:
> > On Mon, Aug 18, 2014 at 03:53:08PM -0400, jonsmirl at gmail.com wrote:
> >> On Mon, Aug 18, 2014 at 3:23 PM, Maxime Ripard
> >> <[email-masked]> wrote:
> >> > Hi,
> >> >
> >> > On Mon, Aug 18, 2014 at 02:03:16PM -0400, Jon Smirl wrote:
> >> >> found on Allwinner SoCs.x
> >> >>
> >> >> Signed-off-by: Jon Smirl <[email-masked]>
> >> >
> >> > Is there any notable difference with Alexandre's driver?
> >> > https://lkml.org/lkml/2014/5/19/568
> >> >
> >> > If so, why didn't you posted incremental patches on top of his driver?
> >>
> >> Better A10 support.
> >
> > Better how?
> >
> >> And I wrote this one without know about his.
> >
> > So you're just require us to trash an already extensively reviewed
> > driver and start from scratch again?
> 
> Forget mine then.
> 
> Problems in the other one....
> 1) The math is not right in either patch. Selsinork has been checking
> mine with a scope and just found another math error in mine. The
> internal math needs to be done in picoseconds or round off errors mess
> up the high frequency outputs (24Mhz, 12Mhz, 8Mhz, ...).

I don't have an oscilloscope so I can't check the exact output but I4ll
try to think about it.

> 3) By-pass mode on the A20 is not implemented.

I'm not sure there is a real use case here, using the bypass only allows
for one duty cycle of 50% with a period of 41.6ns so I think it is
preferable to get an error instead of a bogus output.

> 2) A10 is not correctly handled. Specifically the prescaler is
> different on the A10 vs A20.
> 

I'll change that.

-- 
Alexandre Belloni, Free Electrons
Embedded Linux, Kernel and Android engineering
http://free-electrons.com